#include "clipline.h"

// ClipLine class member function defined :
ClipLine::ClipLine(){
	endpoint0[0]=0;
	endpoint0[1]=0;
	endpoint0[2]=0;
	endpoint0[3]=1;
	endpoint1[0]=0;
	endpoint1[1]=0;
	endpoint1[2]=0;
	endpoint1[3]=1;
};

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
// operator () , sets internal vectors to equal parameters given.

void ClipLine::Initialize(const vector& v1,const vector& v2){
	endpoint0=v1;
	endpoint1=v2;
};
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
// ClipLine assignment operator, calls vector assignment =.
ClipLine& ClipLine::operator=(const ClipLine& L){
	endpoint0=L[0];
	endpoint1=L[1];
	accept=L.accept;
   return *this;
};
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
vector ClipLine::operator[](int i) const{
	assert((i==0)||(i==1));  // bounds check.
	if (i==0) {  return ( endpoint0 ); };
	return (endpoint1);
};
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
vector& ClipLine::operator[](int i){
	assert((i==0)||(i==1));  // bounds check.
	if (i==0) {  return ( endpoint0 ); };
	return (endpoint1);
};
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
// line constructor: construct a line from 2 points.
ClipLine::ClipLine(const point& e0,const point& e1){
	endpoint0 = e0.coords();
	endpoint1 = e1.coords();
	accept=FALSE;
};
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
// line constructor : construct a line from 2 vectors
ClipLine::ClipLine(const vector& e0,const vector& e1){
	endpoint0 =e0;
	endpoint1 =e1;
	accept=FALSE;
};
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

