// COMMDEFS.H
// Gregory Ecker 7/22/94
// Graphics Programming
// Prof. Velho
// common definitions used by
//	matrix,vector,polygon,point,clipline

#ifndef _COMMDEFS_H
#define _COMMDEFS_H

// typical offset into device coordinates, defines origin to be
// 320,240 in 640x480 16 colors mode.
#define StandardTx 320
#define StandardTy 240

// display textual polygon data ( 0 == don't display)
#define DISPLAY_DATA 1

// default data file for polygon data:
#define INFILENAME "poly.dat"

// aperture of viewing lens  ( 50-150 ):
#define VIEW_DISTANCE 200

// #defines for fileopen modes. To be used for reading + creating datafiles.
#define READ "rt"    // Open for reading only
#define WRITE "wt"   // Create for writing
		     // If a file by that name already exists, it will be overwritten.
#define APPEND "at"  // Append; open for writing at end of file, or create for
		     // writing if the file does not exist.
#define UPDATE "rt+" // Open an existing file for update (reading and writing)
#define CREATE "wt+" // Create a new file for update (reading and writing).
		     // If a file by that name already exists, it will be overwritten.
#define OAPPEND "at+" // Open for append; open for update at the end of the file, or
		      // create if the file does not exist.

// #defines for codes for clip rectangle sides (for line-clip).
//   all numbers represent 4-bit codes.
#define TOP 8	 // 1st bit = outside halfplane of top edge, above top edge.
#define BOTTOM 4 // 2nd bit = below bottom edge.
#define RIGHT 2  // 3rd bit = right of right edge.
#define LEFT 1   // 4th bit = left of left edge.

#define TRUE 1
#define FALSE 0
typedef unsigned char BOOLEAN;

// uncomment this line for no assertion tests:
// #define NDEBUG

#define NOTGROUPED  -1 // indicates a primitive is not part of an object.

// defined constants for size and position of buttons:
// button position information
// four constants representing the 6 button rectangle.
#define XMINB 0
#define XMAXB 50
#define YMINB 300
#define YMAXB 450

#define PROTX 25     // split between positive/negative rotaion buttons
#define MAXXROTY 350 // anything less is an x-rot
#define MAXYROTY 400 // anything less is a y-rot
		     // otherwise it is a z-rot.
#define XOFF 6      // distance from left button of marking 'x'
#define YOFF 23


#endif