// Gregory Ecker
// Graphics programming
// Prof. Velho
// test of fileio functions.
#include <graphics.h>
#include <conio.h>
#include <process.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>	// delay();
#include <string.h>

#include "commdefs.h"
#include "matrix.h"
#include "point.h"
#include "polygon.h"
#include "clipline.h"
#include "fileio.h"


// depth of letters:
#define DEPTH 10
// time (milleseconds) between each refresh
#define DELAY 15
// clipping rectangle distances from origin:
#define WIDTH 300    // real values are twice these (for each direction)
#define HEIGHT 20
#define MIDpX 120  // device coordinates of origin.
#define MIDpY 140
#define SPACE 60   // space between letters

void project_all_polygon_copies(polygon** polylist,int numpoly);
void draw_all_polygon_copies(polygon** polylist,int numpoly);
//void delete_all_polygon_copies(polygon** polylist,int numpoly);
void apply_matrix_to_all_polygon_copies(polygon** polylist,matrix *which,
   int numpoly);


void main(int argc,char* argv[])
{
   char filestring[9];
  // if input file not given on the command line : ask for it.
   if(argc != 2){
	printf("please specify input file :");
	scanf("%s", &filestring);
     } else {
      strcpy(filestring,argv[1]);
     };

   polygon **PolyList,**copyList;
   FILE *fileHandle;
   int numpoly;

  ::clrscr();
				      //argv[1]
  fileHandle= OpenDataFile(fileHandle,filestring,READ);
  printf("reading polygon data from %s.. \n",filestring);

  // get number of polygons in scene:
  numpoly=ReadNumPolygons(fileHandle);

  // allocate space for pointers to all polygons:
  PolyList = (polygon**) new polygon[numpoly] ;

  ReadPolygonList(fileHandle,PolyList,numpoly);

  printf("\n polygon list : ");
  for(int p=0;p<numpoly;p++){
    DisplayPolyData(PolyList[p]);
   }



  printf("\n \n press any key to view data..");
  getch();

		int gdriver = DETECT, gmode, errorcode;
		 //     "y:\\bin\\bc3\\bgi"  "d:\\borlandc\\bgi"
		 //   errorcode = registerbgidriver(EGAVGA_driver);
		initgraph(&gdriver, &gmode,"y:\\bin\\bc3\\bgi");
		errorcode = graphresult();
		if (errorcode != grOk){
		   printf("Graphics error: %s\n", grapherrormsg(errorcode));
		   printf("Press any key to halt:");
		   getch();
		   exit(1);
		}


  // display all file data graphically:

  // rotation matrices :
      float theta=0.11;	// angle of rotation (radians)
       matrix Rx,Ry,Rz,NRx,NRy,NRz;

       matrix MirrorX,Perspect;
       MirrorX.Ymirror();

       Rx.Xrotate(theta);
       Rz.Zrotate(theta);
       Ry.Yrotate(theta);

       NRx.NXrotate(theta);
       NRy.NYrotate(theta);
       NRz.NZrotate(theta);
     int count=0;
     char ch='o'; // meaningless char.
     float zINCVAL=1.0;
     matrix *which=&NRy,*which2=&NRx,*which3=&NRz;
     matrix concatmat,Ident;

BOOLEAN Xb=FALSE,Yb=FALSE,Zb=FALSE,NXb=FALSE,NYb=FALSE,NZb=FALSE;

 ::setwritemode(XOR_PUT);
 ::setcolor(GREEN);

// allocate space for pointers to polygon copies:
 copyList = (polygon**) new polygon[numpoly];

 while((ch != 'x') && (ch != 'X')){

    if(kbhit()){
	 ch=getch();
		 } //endif
	 switch(ch){
	    case 'q' : { if(Xb==TRUE){Xb=FALSE;NXb=FALSE;
				  } else
			     { Xb=TRUE;NXb=FALSE; }; break;};

	    case 'Q' : { if(NXb==TRUE) {NXb=FALSE;Xb=FALSE;}
				 else{ NXb=TRUE; Xb=FALSE;};
				 break;};

	    case 'a' : { if(Yb==TRUE){Yb=FALSE;NYb=FALSE;
				  }else
				 { Yb=TRUE; NYb=FALSE;
				 }; break; }

	    case 'A' : { if(NYb==TRUE){NYb=FALSE;Yb=FALSE;
				 } else{ NYb=TRUE; Yb=FALSE; };
				 break; }

	    case 'z' : { if(Zb==TRUE){ Zb=FALSE;NZb=FALSE; }
				 else{ Zb=TRUE; NZb=FALSE;};
				 break;}

	    case 'Z' : { if(NZb==TRUE){NZb=FALSE;Zb=FALSE;
				 }
				 else{NZb=TRUE; Zb=FALSE;};
				 break;}
	   };
	 if(ch != 'x') { ch='o'; };

if((Xb==TRUE)||(NXb==TRUE)||(Yb==TRUE)||(NYb==TRUE)||(Zb==TRUE)||(NZb==TRUE)){
 if((Xb==TRUE) || (NXb==TRUE)){
      if(Xb==TRUE){
	  which=&Rx;
	 } else
	{
	  which=&NRx;
	};
      for(int i5=0;i5<numpoly;i5++){
		PolyList[i5]->Apply(*which);
	    }
  };

if((Yb==TRUE)||(NYb==TRUE)){
     if(Yb==TRUE){
       which2=&Ry;
      } else
       {
	which2=&NRy;
       };
      for(int i4=0;i4<numpoly;i4++){
		PolyList[i4]->Apply(*which2);
	    }
  };

if((Zb==TRUE)||(NZb==TRUE)){
       if(Zb==TRUE){
	 which3=&Rz;
	} else {
	 which3=&NRz;
	};
      for(int i3=0;i3<numpoly;i3++){
		PolyList[i3]->Apply(*which3);
	    }
  };

};

    // create copies of all polygons:
	for(int i=0;i<numpoly;i++){
		copyList[i]= new polygon(*PolyList[i]);
	    }



	project_all_polygon_copies(copyList,numpoly);

     // draw all copies of polygons:
	 draw_all_polygon_copies(copyList,numpoly);

	 delay(DELAY);

	 draw_all_polygon_copies(copyList,numpoly);

	 for(int i2=0;i2<numpoly;i2++){
		delete copyList[i2];
	   }

	 count++;
     };


  ::closegraph();
  ::fclose(fileHandle);
};

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// apply projection matrix to all polygons in world polygon list.

void  project_all_polygon_copies(polygon** polylist,int numpoly){
	   for(int i=0;i<numpoly;i++){
		polylist[i]->Project();
	     }
	 };

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// invokes draw member function for every polygon object in world
// polygon list.

void draw_all_polygon_copies(polygon** polylist,int numpoly){
	for(int i=0; i<numpoly; i++){
		polylist[i]->Draw();
	   }
};

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// applies matrix pointed to by '*which' to all polygons in
// world polygon list.

/*void apply_matrix_to_all_polygon_copies(polygon** polylist,matrix *which,
   int numpoly){

}; */

